Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# CORBA_ORB Class Reference

ORB pseudo-objref. More...

`#include <ORB.h>`

Collaboration diagram for CORBA_ORB:

[legend]
List of all members.

## Public Types
typedef char * | ObjectId
typedef CORBA::String_var | ObjectId_var
typedef CORBA::String_out | ObjectId_out
typedef CORBA_ORB_ObjectIdList | ObjectIdList
typedef CORBA_ORB_ObjectIdList_var | ObjectIdList_var
typedef CORBA_ORB_ObjectIdList_out | ObjectIdList_out
typedef CORBA_ORB_ObjectIdList * | ObjectIdList_ptr
typedef CORBA_ORB_RequestSeq | RequestSeq
typedef CORBA_ORB_RequestSeq_var | RequestSeq_var
typedef CORBA_ORB_RequestSeq_out | RequestSeq_out
typedef CORBA_ORB_ptr | _ptr_type
typedef CORBA_ORB_var | _var_type
## Public Methods
char * | id (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
| Return this ORB's ORBid. More...
CORBA::Object_ptr | string_to_object (const char *str ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Turn a string-ified object reference back into an object pointer. More...
char * | object_to_string (CORBA::Object_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Turn an object reference into a string. More...
CORBA::ValueFactory | register_value_factory (const char *repository_id, CORBA::ValueFactory factory ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | unregister_value_factory (const char *repository_id ACE_ENV_ARG_DECL_WITH_DEFAULTS)
CORBA::ValueFactory | lookup_value_factory (const char *repository_id ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | create_list (CORBA::Long count, CORBA::NVList_ptr &new_list ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | create_named_value (CORBA::NamedValue_ptr &nmval ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | create_exception_list (CORBA::ExceptionList_ptr &exclist ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | create_environment (CORBA::Environment_ptr &new_env ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | create_context_list (CORBA::ContextList_ptr &ctxtlist ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | get_default_context (CORBA::Context_ptr &ctx ACE_ENV_ARG_DECL_WITH_DEFAULTS)
CORBA::Boolean | get_service_information (CORBA::ServiceType service_type, CORBA::ServiceInformation_out service_information ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | send_multiple_requests_oneway (const CORBA_ORB_RequestSeq &req ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | send_multiple_requests_deferred (const CORBA_ORB_RequestSeq &req ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | get_next_response (CORBA_Request_ptr &req ACE_ENV_ARG_DECL_WITH_DEFAULTS)
CORBA::Boolean | poll_next_response (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
CORBA::TypeCode_ptr | create_struct_tc (const char *id, const char *name, const CORBA::StructMemberSeq &members ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
| The ORB TypeCode creation functions. More...
CORBA::TypeCode_ptr | create_union_tc (const char *id, const char *name, CORBA::TypeCode_ptr discriminator_type, const CORBA::UnionMemberSeq &members ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_enum_tc (const char *id, const char *name, const CORBA::EnumMemberSeq &members ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_alias_tc (const char *id, const char *name, CORBA::TypeCode_ptr original_type ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_exception_tc (const char *id, const char *name, const CORBA::StructMemberSeq &members ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_interface_tc (const char *id, const char *name ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_string_tc (CORBA::ULong bound ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_wstring_tc (CORBA::ULong bound ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_fixed_tc (CORBA::UShort digits, CORBA::UShort scale ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_sequence_tc (CORBA::ULong bound, CORBA::TypeCode_ptr element_type ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_array_tc (CORBA::ULong length, CORBA::TypeCode_ptr element_type ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_value_tc (const char *id, const char *name, CORBA::ValueModifier type_modifier, CORBA::TypeCode_ptr concrete_base, const CORBA::ValueMemberSeq &members ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_value_box_tc (const char *id, const char *name, CORBA::TypeCode_ptr boxed_type ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_native_tc (const char *id, const char *name ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_recursive_tc (const char *id ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_abstract_interface_tc (const char *id, const char *name ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
CORBA::TypeCode_ptr | create_local_interface_tc (const char *id, const char *ame ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
void | run (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
| Instructs the ORB to initialize itself and run its event loop in the current thread, not returning until the ORB has shut down. More...
void | run (ACE_Time_Value &tv ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Instructs the ORB to initialize itself and run its event loop in the current thread, not returning until the ORB has shut down or the time value specified through <tv> has expired. More...
void | run (ACE_Time_Value *tv ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Instructs the ORB to initialize itself and run its event loop in the current thread, not returning until the ORB has shut down or the time value specified through <tv> has expired. More...
CORBA::Boolean | work_pending (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
| Returns an indication of whether the ORB needs to perform some work. More...
CORBA::Boolean | work_pending (ACE_Time_Value &tv ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Returns an indication of whether the ORB needs to perform some work but will look for work pending for no more than the specified time. This is useful for implementing an event loop with an idle timeout. More...
void | perform_work (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
| This operation performs an implementation-defined unit of work. More...
void | perform_work (ACE_Time_Value &ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | perform_work (ACE_Time_Value *ACE_ENV_ARG_DECL_WITH_DEFAULTS)
void | shutdown (CORBA::Boolean wait_for_completion=0 ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| This operation instructs the ORB to shut down. More...
void | destroy (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
| Explicitly destroy the ORB, releasing any resources. More...
CORBA_Object_ptr | resolve_initial_references (const char *name ACE_ENV_ARG_DECL_WITH_DEFAULTS)
CORBA_Object_ptr | resolve_initial_references (const char *name, ACE_Time_Value *timeout ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| This method acts as a mini-bootstrapping Naming Service, which is provided by the ORB for certain well-known object references. More...
void | register_initial_reference (const char *id, CORBA::Object_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Register an object reference with the ORB. More...
CORBA_ORB_ObjectIdList_ptr | list_initial_services (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS)
| Returns a sequence of ObjectIds that lists which objects have references available via the initial references mechanism. More...
CORBA::Policy_ptr | create_policy (CORBA::PolicyType type, const CORBA::Any &val ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, CORBA::PolicyError)
CORBA::Policy_ptr | _create_policy (CORBA::PolicyType type ACE_ENV_ARG_DECL) throw (CORBA::SystemException, CORBA::PolicyError)
| Create an empty policy, usually to be filled in later by demarshaling. More...
CORBA_Object_ptr | resolve_root_poa (ACE_ENV_SINGLE_ARG_DECL)
| Resolve the POA. More...
CORBA::ULong | _incr_refcnt (void)
CORBA::ULong | _decr_refcnt (void)
void | _use_omg_ior_format (CORBA::Boolean ior)
| Set the IOR flag. Get the IOR flag. More...
CORBA::Boolean | _use_omg_ior_format (void)
void | _optimize_collocation_objects (CORBA::Boolean opt)
| Set collocation optimization status. Get collocation optimization status. More...
CORBA::Boolean | _optimize_collocation_objects (void) const
TAO_ORB_Core * | orb_core (void) const
| Get the ORB core. More...
const ACE_CString & | _tao_ft_client_id (void)
| TAO specific extension to get and set the client ID. More...
void | _tao_ft_client_id (const char *id)
ACE_Time_Value * | get_timeout (void)
| Get the Timeout value. More...
## Static Public Methods
CORBA::ORB_ptr | _duplicate (CORBA::ORB_ptr orb)
| Return a duplicate of <{orb}>. When work with this duplicate is complete, it should be freed up using <CORBA::release()>. More...
CORBA::ORB_ptr | _nil (void)
| Returns a pointer to a nil ORB, i.e., an non-existent ORB. This can be used for initialization or in comparisons. More...
void | init_orb_globals (ACE_ENV_SINGLE_ARG_DECL)
| Initialize the ORB globals correctly, i.e., only when they haven't been initialized yet. More...
void | _tao_unexpected_exception (void)
## Static Public Attributes
CORBA::TypeCode_ptr | _tc_ObjectId
CORBA::TypeCode_ptr | _tc_ObjectIdList
## Protected Methods
| CORBA_ORB (TAO_ORB_Core *orb_core)
| ~CORBA_ORB (void)
CORBA_Object_ptr | resolve_poa_current (ACE_ENV_SINGLE_ARG_DECL)
| Resolve the POA current. More...
CORBA_Object_ptr | resolve_policy_manager (ACE_ENV_SINGLE_ARG_DECL_NOT_USED)
| Resolve the Policy Manager for this ORB. More...
CORBA_Object_ptr | resolve_policy_current (ACE_ENV_SINGLE_ARG_DECL_NOT_USED)
| Resolve the Policy Current for this thread. More...
## Private Methods
CORBA::Object_ptr | resolve_service (TAO_MCAST_SERVICEID service_id ACE_ENV_ARG_DECL)
| Resolve the given service based on the service ID. More...
CORBA::Object_ptr | ior_string_to_object (const char *ior ACE_ENV_ARG_DECL)
| Convert an OMG IOR into an object reference. More...
CORBA::Object_ptr | url_ior_string_to_object (const char *ior ACE_ENV_ARG_DECL)
| Convert an URL style IOR into an object reference. More...
void | check_shutdown (ACE_ENV_SINGLE_ARG_DECL)
| Check if ORB has shutdown. If it has, throw an exception. More...
void | set_timeout (ACE_Time_Value *timeout)
| Set the timeout value. More...
| CORBA_ORB (const CORBA_ORB &)
CORBA_ORB & | operator= (const CORBA_ORB &)
## Private Attributes
TAO_SYNCH_MUTEX | lock_
| lock required for mutual exclusion between multiple threads. More...
u_int | refcount_
| Maintains a reference count of number of instantiations of the ORB. More...
TAO_ORB_Core * | orb_core_
| The ORB_Core that created us.... More...
TAO_ValueFactory_Map * | valuetype_factory_map_
| If non-0 then this is the Factory for OBV unmarshaling. More...
CORBA::Boolean | use_omg_ior_format_
| Decides whether to use the URL notation or to use IOR notation. More...
ACE_Time_Value * | timeout_
| Timeout value. More...
## Static Private Attributes
int | orb_init_count_ = 0
| Count of the number of times that <ORB_init> has been called. More...
## Friends
class | TAO_ORB_Core
TAO_Export TAO_ORB_Core * | TAO_ORB_Core_instance (void)

## Detailed Description

ORB pseudo-objref.

The "ORB" pseudo-object is used in bootstrapping, such as to create object references from strings. This class is intended to be inherited by others, which will provide some more of the CORBA support. Implementations of this "CORBA::ORB" class must know how to create stringify/destringify their objrefs, as well as how to marshal and unmarshal them.

## Member Typedef Documentation

typedef CORBA_ORB_ptr CORBA_ORB::_ptr_type

typedef CORBA_ORB_var CORBA_ORB::_var_type

typedef char* CORBA_ORB::ObjectId

typedef CORBA::String_out CORBA_ORB::ObjectId_out

typedef CORBA::String_var CORBA_ORB::ObjectId_var

typedef CORBA_ORB_ObjectIdList CORBA_ORB::ObjectIdList

typedef CORBA_ORB_ObjectIdList_out CORBA_ORB::ObjectIdList_out

typedef CORBA_ORB_ObjectIdList* CORBA_ORB::ObjectIdList_ptr

typedef CORBA_ORB_ObjectIdList_var CORBA_ORB::ObjectIdList_var

typedef CORBA_ORB_RequestSeq CORBA_ORB::RequestSeq

typedef CORBA_ORB_RequestSeq_out CORBA_ORB::RequestSeq_out

typedef CORBA_ORB_RequestSeq_var CORBA_ORB::RequestSeq_var

## Constructor & Destructor Documentation

CORBA_ORB::CORBA_ORB | ( | TAO_ORB_Core * | orb_core | ) | `[protected]`

CORBA_ORB::~CORBA_ORB | ( | void |  | ) | `[protected]`

CORBA_ORB::CORBA_ORB | ( | const CORBA_ORB & |  | ) | `[private]`

## Member Function Documentation

CORBA::Policy_ptr CORBA_ORB::_create_policy | ( | CORBA::PolicyType type | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, CORBA::PolicyError)

| Create an empty policy, usually to be filled in later by demarshaling.

ACE_INLINE CORBA::ULong CORBA_ORB::_decr_refcnt | ( | void |  | ) |

ACE_INLINE CORBA::ORB_ptr CORBA_ORB::_duplicate | ( | CORBA::ORB_ptr | obj | ) | `[static]`

| Return a duplicate of <{orb}>. When work with this duplicate is complete, it should be freed up using <CORBA::release()>.

ACE_INLINE CORBA::ULong CORBA_ORB::_incr_refcnt | ( | void |  | ) |

ACE_INLINE CORBA::ORB_ptr CORBA_ORB::_nil | ( | void |  | ) | `[static]`

| Returns a pointer to a nil ORB, i.e., an non-existent ORB. This can be used for initialization or in comparisons.

CORBA::Boolean CORBA_ORB::_optimize_collocation_objects | ( | void |  | ) | const

void CORBA_ORB::_optimize_collocation_objects | ( | CORBA::Boolean | opt | ) |

| Set collocation optimization status. Get collocation optimization status.

void CORBA_ORB::_tao_ft_client_id | ( | const char * | id | ) |

const ACE_CString & CORBA_ORB::_tao_ft_client_id | ( | void |  | ) |

| TAO specific extension to get and set the client ID. The client id can be set by the application which would be used by the FT service. As there are no specific interfaces defined in the spec, we have this prorpietary extensions

void CORBA_ORB::_tao_unexpected_exception | ( | void |  | ) | `[static]`

ACE_INLINE CORBA::Boolean CORBA_ORB::_use_omg_ior_format | ( | void |  | ) |

ACE_INLINE void CORBA_ORB::_use_omg_ior_format | ( | CORBA::Boolean | ior | ) |

| Set the IOR flag. Get the IOR flag.

void CORBA_ORB::check_shutdown | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[private]`

| Check if ORB has shutdown. If it has, throw an exception.

CORBA::TypeCode_ptr CORBA_ORB::create_abstract_interface_tc | ( | const char * | id,
|  | const char *name | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_alias_tc | ( | const char * | id,
|  | const char * | name,
|  | CORBA::TypeCode_ptr original_type | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_array_tc | ( | CORBA::ULong | length,
|  | CORBA::TypeCode_ptr element_type | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

void CORBA_ORB::create_context_list | ( | CORBA::ContextList_ptr &ctxtlist | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

CORBA::TypeCode_ptr CORBA_ORB::create_enum_tc | ( | const char * | id,
|  | const char * | name,
|  | const CORBA::EnumMemberSeq &members | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)

void CORBA_ORB::create_environment | ( | CORBA::Environment_ptr &new_env | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

void CORBA_ORB::create_exception_list | ( | CORBA::ExceptionList_ptr &exclist | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

CORBA::TypeCode_ptr CORBA_ORB::create_exception_tc | ( | const char * | id,
|  | const char * | name,
|  | const CORBA::StructMemberSeq &members | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_fixed_tc | ( | CORBA::UShort | digits,
|  | CORBA::UShort scale | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_interface_tc | ( | const char * | id,
|  | const char *name | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

void CORBA_ORB::create_list | ( | CORBA::Long | count,
|  | CORBA::NVList_ptr &new_list | ACE_ENV_ARG_DECL
| ) |

CORBA::TypeCode_ptr CORBA_ORB::create_local_interface_tc | ( | const char * | id,
|  | const char *ame | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)

void CORBA_ORB::create_named_value | ( | CORBA::NamedValue_ptr &nmval | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

CORBA::TypeCode_ptr CORBA_ORB::create_native_tc | ( | const char * | id,
|  | const char *name | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

CORBA::Policy_ptr CORBA_ORB::create_policy | ( | CORBA::PolicyType | type,
|  | const CORBA::Any &val | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, CORBA::PolicyError)

CORBA::TypeCode_ptr CORBA_ORB::create_recursive_tc | ( | const char *id | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_sequence_tc | ( | CORBA::ULong | bound,
|  | CORBA::TypeCode_ptr element_type | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_string_tc | ( | CORBA::ULong bound | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_struct_tc | ( | const char * | id,
|  | const char * | name,
|  | const CORBA::StructMemberSeq &members | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)

| The ORB TypeCode creation functions.

CORBA::TypeCode_ptr CORBA_ORB::create_union_tc | ( | const char * | id,
|  | const char * | name,
|  | CORBA::TypeCode_ptr | discriminator_type,
|  | const CORBA::UnionMemberSeq &members | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_value_box_tc | ( | const char * | id,
|  | const char * | name,
|  | CORBA::TypeCode_ptr boxed_type | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_value_tc | ( | const char * | id,
|  | const char * | name,
|  | CORBA::ValueModifier | type_modifier,
|  | CORBA::TypeCode_ptr | concrete_base,
|  | const CORBA::ValueMemberSeq &members | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)

CORBA::TypeCode_ptr CORBA_ORB::create_wstring_tc | ( | CORBA::ULong bound | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException)

void CORBA_ORB::destroy | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

| Explicitly destroy the ORB, releasing any resources. Note that TAO *cannot* implicitly release the resources even if you have destroyed all the references to a particular ORB since CORBA::ORB_init() is required to return the same pointer if called with the same ORBid, only after ORB::destroy() is called it may return a new one. The results of multi-threaded applications, trying to destroy () the ORB in one thread and trying to service a request in another thread are not well defined. TAO does not support such cases.

void CORBA_ORB::get_default_context | ( | CORBA::Context_ptr &ctx | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

void CORBA_ORB::get_next_response | ( | CORBA_Request_ptr &req | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

CORBA::Boolean CORBA_ORB::get_service_information | ( | CORBA::ServiceType | service_type,
|  | CORBA::ServiceInformation_out | ACE_ENV_ARG_DECL
| ) |

ACE_Time_Value * CORBA_ORB::get_timeout | ( | void |  | ) |

| Get the Timeout value.

char * CORBA_ORB::id | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

| Return this ORB's ORBid.

void CORBA_ORB::init_orb_globals | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[static]`

| Initialize the ORB globals correctly, i.e., only when they haven't been initialized yet.

CORBA::Object_ptr CORBA_ORB::ior_string_to_object | ( | const char *ior | ACE_ENV_ARG_DECL | ) | `[private]`

| Convert an OMG IOR into an object reference.

CORBA_ORB_ObjectIdList_ptr CORBA_ORB::list_initial_services | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

| Returns a sequence of ObjectIds that lists which objects have references available via the initial references mechanism.

CORBA::ValueFactory CORBA_ORB::lookup_value_factory | ( | const char *repository_id | ACE_ENV_ARG_DECL_NOT_USED | ) |

char * CORBA_ORB::object_to_string | ( | CORBA::Object_ptr obj | ACE_ENV_ARG_DECL | ) |

| Turn an object reference into a string. Each type of ORB, e.g. an IIOP ORB, must implement this. This can be used by servers to publish their whereabouts to clients. The output of this is typically eventually given to <string_to_object()> as an argument.

CORBA_ORB& CORBA_ORB::operator= | ( | const CORBA_ORB & |  | ) | `[private]`

ACE_INLINE TAO_ORB_Core * CORBA_ORB::orb_core | ( | void |  | ) | const

| Get the ORB core.

void CORBA_ORB::perform_work | ( | ACE_Time_Value * | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

void CORBA_ORB::perform_work | ( | ACE_Time_Value & | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

void CORBA_ORB::perform_work | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

| This operation performs an implementation-defined unit of work. Note that the default behavior is to block if the unit of work is not present; this behavior can be modified by passing an appropriate <ACE_Time_Value> as described in run().

CORBA::Boolean CORBA_ORB::poll_next_response | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

void CORBA_ORB::register_initial_reference | ( | const char * | id,
|  | CORBA::Object_ptr obj | ACE_ENV_ARG_DECL
| ) |

| Register an object reference with the ORB.

CORBA::ValueFactory CORBA_ORB::register_value_factory | ( | const char * | repository_id,
|  | CORBA::ValueFactory factory | ACE_ENV_ARG_DECL
| ) |

CORBA_Object_ptr CORBA_ORB::resolve_initial_references | ( | const char * | name,
|  | ACE_Time_Value *timeout | ACE_ENV_ARG_DECL
| ) |

| This method acts as a mini-bootstrapping Naming Service, which is provided by the ORB for certain well-known object references. TAO supports the "NameService", "TradingService", "RootPOA", "ImplRepo", and "POACurrent" via this method. The <timeout> value bounds the amount of time the ORB blocks waiting to resolve the service. This is most useful for bootstrapping remote services, such as the "NameService" or "TradingService", that are commonly resolved via multicast. By default, the value is 0, which means "use the <TAO_DEFAULT_SERVICE_RESOLUTION_TIMEOUT> timeout period". Note that by using a default value for the <timeout> parameter, TAO will remains compliant with the CORBA <resolve_initial_references> specification.

CORBA_Object_ptr CORBA_ORB::resolve_initial_references | ( | const char *name | ACE_ENV_ARG_DECL | ) |

CORBA_Object_ptr CORBA_ORB::resolve_poa_current | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[protected]`

| Resolve the POA current.

CORBA_Object_ptr CORBA_ORB::resolve_policy_current | ( | ACE_ENV_SINGLE_ARG_DECL_NOT_USED |  | ) | `[protected]`

| Resolve the Policy Current for this thread.

CORBA_Object_ptr CORBA_ORB::resolve_policy_manager | ( | ACE_ENV_SINGLE_ARG_DECL_NOT_USED |  | ) | `[protected]`

| Resolve the Policy Manager for this ORB.

CORBA_Object_ptr CORBA_ORB::resolve_root_poa | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) |

| Resolve the POA.

CORBA::Object_ptr CORBA_ORB::resolve_service | ( | TAO_MCAST_SERVICEID service_id | ACE_ENV_ARG_DECL | ) | `[private]`

| Resolve the given service based on the service ID.

void CORBA_ORB::run | ( | ACE_Time_Value *tv | ACE_ENV_ARG_DECL | ) |

| Instructs the ORB to initialize itself and run its event loop in the current thread, not returning until the ORB has shut down or the time value specified through <tv> has expired. If an error occurs during initialization or at run-time, a CORBA system exception will be thrown. <tv> is reduced by the amount of time spent in this call. If <tv> is 0, it means that the timeout is infinite. If <tv> is ACE_Time_Value::zero, it specifies to poll and does not block.

void CORBA_ORB::run | ( | ACE_Time_Value &tv | ACE_ENV_ARG_DECL | ) |

| Instructs the ORB to initialize itself and run its event loop in the current thread, not returning until the ORB has shut down or the time value specified through <tv> has expired. If an error occurs during initialization or at run-time, a CORBA system exception will be thrown. <tv> is reduced by the amount of time spent in this call.

void CORBA_ORB::run | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

| Instructs the ORB to initialize itself and run its event loop in the current thread, not returning until the ORB has shut down. If an error occurs during initialization or at run-time, a CORBA system exception will be thrown.

void CORBA_ORB::send_multiple_requests_deferred | ( | const CORBA_ORB_RequestSeq &req | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

void CORBA_ORB::send_multiple_requests_oneway | ( | const CORBA_ORB_RequestSeq &req | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

void CORBA_ORB::set_timeout | ( | ACE_Time_Value * | timeout | ) | `[private]`

| Set the timeout value.

void CORBA_ORB::shutdown | ( | CORBA::Boolean wait_for_completion | ACE_ENV_ARG_DECL = 0 ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

| This operation instructs the ORB to shut down. Shutting down the ORB causes all Object Adapters to be shut down. If <wait_for_completion> parameter is TRUE, this operation blocks until all ORB processing (including request processing and object deactivation or other operations associated with object adapters) has completed.

CORBA::Object_ptr CORBA_ORB::string_to_object | ( | const char *str | ACE_ENV_ARG_DECL | ) |

| Turn a string-ified object reference back into an object pointer. Typically these strings are created using <object_to_string()>, but not necessarily locally.

void CORBA_ORB::unregister_value_factory | ( | const char *repository_id | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) |

CORBA::Object_ptr CORBA_ORB::url_ior_string_to_object | ( | const char *ior | ACE_ENV_ARG_DECL | ) | `[private]`

| Convert an URL style IOR into an object reference.

CORBA::Boolean CORBA_ORB::work_pending | ( | ACE_Time_Value &tv | ACE_ENV_ARG_DECL | ) |

| Returns an indication of whether the ORB needs to perform some work but will look for work pending for no more than the specified time. This is useful for implementing an event loop with an idle timeout.

CORBA::Boolean CORBA_ORB::work_pending | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) |

| Returns an indication of whether the ORB needs to perform some work.

## Friends And Related Function Documentation

friend class TAO_ORB_Core`[friend]`

TAO_Export TAO_ORB_Core* TAO_ORB_Core_instance | ( | void |  | ) | `[friend]`

## Member Data Documentation

CORBA::TypeCode_ptr CORBA_ORB::_tc_ObjectId`[static]`

CORBA::TypeCode_ptr CORBA_ORB::_tc_ObjectIdList`[static]`

TAO_SYNCH_MUTEX CORBA_ORB::lock_`[private]`

| lock required for mutual exclusion between multiple threads.

TAO_ORB_Core* CORBA_ORB::orb_core_`[private]`

| The ORB_Core that created us....

int CORBA_ORB::orb_init_count_ = 0`[static, private]`

| Count of the number of times that <ORB_init> has been called.

u_int CORBA_ORB::refcount_`[private]`

| Maintains a reference count of number of instantiations of the ORB.

ACE_Time_Value* CORBA_ORB::timeout_`[private]`

| Timeout value.

CORBA::Boolean CORBA_ORB::use_omg_ior_format_`[private]`

| Decides whether to use the URL notation or to use IOR notation.

TAO_ValueFactory_Map* CORBA_ORB::valuetype_factory_map_`[private]`

| If non-0 then this is the Factory for OBV unmarshaling.

The documentation for this class was generated from the following files:

- ORB.h
- ORB.cpp
- ORB.i